// WinGL L1 0.11e
//
// WinGL𗘗pPȃvO\[X(2)
//
// darview - DARt@C\c[
//
// $Header: /WinGL/darview/darview.cpp 6     97/02/01 17:32 Koizuka $
//
#include <string.h>
#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#pragma hdrstop
#include "utils.h"
#include "WinGL.h"
#include "game.h"
using namespace WinGL;

//
// class derrived GApp
//
class DarviewApp : public GApp {
public:
	DarviewApp(HINSTANCE hInst,HINSTANCE hPrev, LPSTR szCmdLine, int sw) ;
	~DarviewApp();
} ;

//
// class derrived GGameWindow
//
class DarviewWindow : public GGameWindow {
	WINGL Canvas;        // ` 
	GInputObject Input;  // ͑u 
	HFONT hfont;
	BOOL dirty;
	GScrollBar ScrollBar;

	int TopY;            // ݂̃f[^̈ԏ̈ʒu 
	int CharHeight;      // 1̍ 
	int TotalHeight;     // Ŝ̍̍v 
	int backcolor;       // wiF 
	int HoldY;           // hbOƂ̊_

public:
	static const int TIMEOUT;

	static char * getClassName() {
		// Windows"WindowNX"ԂB
		//
		return "DarviewWindow";
	}
	static char * getMenuName() {
		// menu\[XԂBmenuȂȂNULL
		//
		return NULL;
	}

	static BOOL RegisterClass() {
		return Register(
			getClassName(),
			LoadCursor(NULL,IDC_ARROW),	            // }EXJ[\(ʏ)
			LoadIcon(MainApp->getInstance(),"AppIcon"),   // icon
			getMenuName(),                                // menu name
			0,                                            // background brush
			0                                             // class style
		);
	}

private:
	//
	void GameStart() ;

	void InGameProc(HDC hdc) ;
	void DirtyPaint() ;


	// override function..
	virtual void OnPaint(HDC hdc) ;
	virtual LRESULT OnSize() ;

	virtual void OnKeyDown( int wVKey, DWORD ) ;

	virtual BOOL OnPeriod(HDC hdc, UINT drop) ;

	virtual void OnLButtonDown( WPARAM fwKey, WORD x, WORD y ) ;
	virtual void OnLButtonUp( WPARAM fwKey, WORD x, WORD y ) ;
	virtual void OnMouseMove( WPARAM fwKey, WORD x, WORD y ) ;
	virtual void OnRButtonDown( WPARAM fwKey, WORD x, WORD y ) ;
	virtual LRESULT Dispatch() ;

	void ResetScrollBar( BOOL fRedraw );
	BOOL MoveY( int newTop ) ;

public:
	DarviewWindow( LPCSTR caption, HWND hwndParent = 0) ;
	int GetTotalHeight() const { return TotalHeight; }
} ;

//
// Implementation...
//
const int DarviewWindow::TIMEOUT = 25 ;				// b40̕`

void DarviewWindow::GameStart() {
	TopY = 0;
	TotalHeight = 0;

	for ( unsigned int n = 0 ; n < WinGLPatNum ; ++n ) {
		int h = PatSizeY(n);
		if ( h < CharHeight ) h = CharHeight ;
		TotalHeight += h + 4;
	}
}


// //
void DarviewWindow::ResetScrollBar( BOOL fRedraw ) {
	GScrollParam sp;
	sp.min = 0;
	sp.max = TotalHeight - 1;
	sp.pos = TopY;
	sp.page = Canvas.Height();
	ScrollBar.Set( getHWND(), SB_VERT, &sp, fRedraw );
}

void DarviewWindow::DirtyPaint() {
	int wheight = Canvas.Height();

	// Swi`
	Canvas.Clear(backcolor);

	// o
	static int maxmaxwid = 0;
	int maxwid = 0;
	HDC dc = Canvas.GetDC();
	HFONT lastfont = (HFONT)SelectObject(dc, hfont);
	int y = 0 - TopY;
	unsigned int n;
	SIZE size;
	for ( n = 0 ; n < WinGLPatNum ; ++n ) {
		char s[40];
		int h = PatSizeY(n);
		if ( h < CharHeight ) h = CharHeight ;

		if ( y >= -h && y <= Canvas.Height() ) {
			wsprintf(s, "#%d: %dx%dx%d %s", n,PatSizeX(n),PatSizeY(n), PatBytesPixel(n) * 8, PatGetName(n) ? PatGetName(n) : "" );
			TextOut(dc,0, y + (h - CharHeight)/2, s, strlen(s));
			GetTextExtentPoint(dc, s, strlen(s), &size );
			if ( size.cx > maxwid )
				maxwid = size.cx;
		}
		y += h + 4 ;
	}
	SelectObject(dc, lastfont);
	Canvas.ReleaseDC();
	if ( maxmaxwid < maxwid ) {
		maxmaxwid = maxwid;
	} else {
		maxwid = maxmaxwid;
	}

	maxwid += 2 ;

	// p^[
	y = 0 - TopY;
	for ( n = 0 ; n < WinGLPatNum ; ++n ) {
		int h = PatSizeY(n);
		if ( h < CharHeight ) h = CharHeight ;
		if ( y + h > 0 ) {
			if ( y >= wheight )
				break;
			WGLDRAWSTRUCT wds;
			wds.flags = 0;
			wds.x = maxwid;
			wds.y = y + (h - PatSizeY(n)) / 2;
			wds.patnum = n;
			Canvas.Draw( &wds );
		}
		y += h + 4 ;
	}
	dirty = FALSE;
}

BOOL DarviewWindow::MoveY( int newTop ) {
	int wheight = Canvas.Height();

	if ( newTop < 0 || TotalHeight <= wheight ) {
		newTop = 0 ;
	} else if ( TotalHeight > wheight && newTop >= TotalHeight - wheight ) {
		newTop = TotalHeight - wheight ;
	}
	if ( newTop != TopY ) {
		TopY = newTop;
		ResetScrollBar( TRUE );
		dirty = TRUE;
		return TRUE;
	}
	return FALSE;
}

LRESULT DarviewWindow::Dispatch() {
	if ( msg != WM_VSCROLL ) {
		return GGameWindow::Dispatch();
	}
	int nScrollCode = LOWORD(wparam);
	int wheight = Canvas.Height();
	int ny = TopY;

	// LN^𓮂

	switch ( nScrollCode ) {
	case SB_LINEUP :
		ny -= 16 ;
		break;
	case SB_LINEDOWN :
		ny += 16 ;
		break;
	case SB_PAGEUP :
		ny -= wheight / 2 ;
		break;
	case SB_PAGEDOWN:
		ny += wheight / 2 ;
		break;
	case SB_TOP :
		ny = 0;
		break;
	case SB_BOTTOM :
		ny = TotalHeight - wheight ;
		break;
	case SB_THUMBTRACK:
		ny = ScrollBar.GetThumbTrack( getHWND(), SB_VERT, wparam, lparam );
		break;
	}

	MoveY( ny );

	if ( dirty ) {
		DirtyPaint();
		InvalidateRect(NULL,FALSE);
		UpdateWindow(getHWND());
	}
	return 0;
}

// ԂĂ΂鏈
void DarviewWindow::InGameProc(HDC hdc ) {
	GInputState stick(Input);	// XeBbN(L[)ǂ
	int wheight = Canvas.Height();
	int ny = TopY;
	int last_backcolor = backcolor;

	// LN^𓮂

	if ( stick.up() ) { // ..
		if ( stick.triggerC() )
			ny -= wheight / 2 ;
		else
			ny -= 16 ;
	}
	if ( stick.down() ) { // ..
		if ( stick.triggerC() )
			ny += wheight / 2 ;
		else
			ny += 16 ;
	}
	if ( stick.triggerG() || stick.left() ) {
		ny -= wheight / 2 ;
	}
	if ( stick.triggerH() || stick.right() ) {
		ny += wheight / 2 ;
	}

	if ( stick.triggerE() ) {
		ny = 0 ;
	} else if ( stick.triggerF() ) {
		ny = TotalHeight - wheight ;
	}

	MoveY(ny);

	if ( stick.triggerA() ) {
		backcolor = 255;
	}
	if ( stick.triggerB() ) {
		backcolor = 0;
	}
	if ( backcolor != last_backcolor ) {
		dirty = TRUE;
	}

	if ( dirty ) {
		DirtyPaint();

		// ʂ֓]
		Canvas.Paint(hdc);
	}
} // InGameProc

// IɌĂяo //
// ̎́AStartPeriod()Ŏw肳B
// ̃vȌꍇ TIMEOUT ɐݒ肳Ă鎞(~bP)ŌĂ΂B
BOOL DarviewWindow::OnPeriod(HDC hdc, UINT ) {
	InGameProc(hdc);
	return TRUE;
}


// ق̃EBhEɉBĂꂽƂp̕` //
// ͉Kv͂ȂB
void DarviewWindow::OnPaint(HDC hdc) {
	Canvas.Paint(hdc,0,0);
}

// EBhETCYύX //
LRESULT DarviewWindow::OnSize() {
	RECT r;
	GetClientRect(getHWND(), &r);
	Canvas.Size(r.right, r.bottom, 0);
	ResetScrollBar( TRUE );
	if ( MoveY(TopY) ) {
		InvalidateRect(0,FALSE);
	}
	DirtyPaint();
	return 0;
}

// }EXE{^ꂽ
void DarviewWindow::OnRButtonDown( WPARAM, WORD, WORD ) {
	backcolor = 255 - backcolor;  // wiF̔]
	DirtyPaint();
	InvalidateRect(NULL,FALSE);
	UpdateWindow(getHWND());
}

// }EX{^ꂽ
void DarviewWindow::OnLButtonDown( WPARAM, WORD, WORD) {
	POINT pt;
	GetCursorPos(&pt);
	HoldY = TopY + pt.y;
	SetCapture(getHWND());
}

// }EX{^ꂽ
void DarviewWindow::OnLButtonUp( WPARAM, WORD, WORD) {
	ReleaseCapture();
}

// }EXړ
void DarviewWindow::OnMouseMove( WPARAM fkey, WORD, WORD) {
	if ( fkey & MK_LBUTTON ) {
		POINT pt;
		GetCursorPos(&pt);
		if ( MoveY(HoldY - pt.y) ) {
			DirtyPaint();
			InvalidateRect(0,FALSE);
			UpdateWindow(getHWND());
		}
	}
}

// L[ꂽ //
void DarviewWindow::OnKeyDown( int wVKey, DWORD ) {
	switch ( wVKey ) {
	case VK_ESCAPE :
		Close();
		break;
	case VK_F3:
		// F3, ESCL[Ń|[Y/ĊJ //
		SetPause(GetPause() == 0);
	}
}

//
// Window쐬
//
DarviewWindow::DarviewWindow( LPCSTR caption, HWND hwndParent) :
 Input(GInputObject::Template1P), backcolor(255), dirty(TRUE),
 GGameWindow( caption, getClassName(), 
 	WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX|WS_THICKFRAME|WS_VSCROLL,
 	CW_USEDEFAULT,0,CW_USEDEFAULT,0, hwndParent) {

	if ( isOk() ) {
		// zVRAM̏
		//
		RECT rect;
		GetClientRect(getHWND(), &rect );
		Canvas.Size(rect.right, rect.bottom, 0, hpal) ;
		
		// tHg쐬
		LOGFONT lf;
		lf.lfHeight = 16;
		lf.lfWidth = 0;
		lf.lfEscapement = 0;
		lf.lfOrientation = 0;
		lf.lfWeight = 0;
		lf.lfItalic = FALSE;
		lf.lfUnderline = FALSE;
		lf.lfStrikeOut = FALSE;
		lf.lfCharSet = ANSI_CHARSET;
		lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
		lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
		lf.lfQuality = DEFAULT_QUALITY;
		lf.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
		lf.lfFaceName[0] = '\0';
		hfont = CreateFontIndirect( &lf );

		HDC dc = Canvas.GetDC();
		HFONT lastfont = (HFONT)SelectObject(dc, hfont);
		SIZE size;
		char s[40];
		wsprintf(s, "#1: 1x1" );
		GetTextExtentPoint(dc, s, strlen(s), &size );
		CharHeight = size.cy ;
		SelectObject(dc, lastfont);
		Canvas.ReleaseDC();

		// L[ATC
		Input.Assign( GInputObject::TriggerE1, VK_HOME );
		Input.Assign( GInputObject::TriggerF1, VK_END );
		Input.Assign( GInputObject::TriggerG1, VK_PRIOR );
		Input.Assign( GInputObject::TriggerH1, VK_NEXT );

		// Jn̂߂̐ݒ菈ł
		GameStart();
	}
}


//
// DarviewApp Implementation
//
DarviewApp::DarviewApp(HINSTANCE hInst,HINSTANCE hPrev, LPSTR szCmdLine, int sw)
 : GApp(hInst,hPrev,szCmdLine,sw) {

	MainApp = this ;
	isok = FALSE;
	if ( !hPrev ) {
		if ( !DarviewWindow::RegisterClass() )
			return;
	}

	//
	// N̏̓RR
	// sAreturn Ηǂ
	//

	if ( PatEntryDARFile( 0, MAXPAT, szCmdLine ) < 1 ) {
		return;
	}

	// ̂
	isok = TRUE;
}

DarviewApp::~DarviewApp() {
}

int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR szCmdLine, int sw) {
	char fn[1024];
	int i = 0;
	while ( szCmdLine[i] == ' ' ) {
		++i ;
	}
	if ( szCmdLine[0] == '\"' ) {
		strcpy( fn, szCmdLine + i + 1 );
		int l = strlen(fn) ;
		if ( l > 1 ) {
			if ( fn[l-1] == '\"' )
				fn[l-1] = '\0';
		}
	} else {
		strcpy( fn, szCmdLine + i );
	}
	WinGLBitsMode(16);

	// AvP[V
	DarviewApp App(hInst, hPrev, fn, sw);
	if ( !App.isOk() ) { // 玸s
		return FALSE;
	}

	// EBhEJ
	DarviewWindow Window( fn );
	if ( !Window.isOk() ) { // 玸s
		MessageBox(0, "EBhEJȂ悤", 0, MB_ICONSTOP|MB_OK );
		return FALSE;
	}
	// 512()
	Window.SetClientSize( 512, Window.GetTotalHeight() < 300 ? Window.GetTotalHeight() : 0 );
	// ĕ\ON!
	Window.Show(sw);
	Window.StartPeriod( DarviewWindow::TIMEOUT, 0 ) ;  // ɂOnPeriodԂĂ΂悤ɂȂ

	// ēJnB
	return App.MessageLoop();
}
